<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>裁判辅助工具</title>
    <!-- 引入样式 -->
    <link rel="stylesheet" href="https://unpkg.com/element-ui/lib/theme-chalk/index.css">
    <!-- 引入组件库 -->
    <script src="https://unpkg.com/vue@2/dist/vue.js"></script>
    <!-- 引入组件库 -->
    <script src="https://unpkg.com/element-ui/lib/index.js"></script>
</head>
<style>
    .el-checkbox__label {
        font-size: 16px;
    }

    .pannel {
        margin: 20px;
    }

    .delete {
        text-decoration: line-through;
    }

    .war-details {
        border: 1px solid #000000;
        border-collapse: collapse;
    }

    .war-details td {
        border: 1px solid #000000;
    }

    .left {
        padding: 0 15px;
        text-align: left;
    }

    .right {
        text-align: right;
    }

    .center {
        width: 100%;
        text-align: center
    }

    .center select {
        text-align: center;
        border: none;
        outline: none;
        box-shadow: none;
        background: none;
        /* 去掉三角 */
        appearance: none;
        /* 兼容Firefox */
        -moz-appearance: none;
        /* 兼容Safari 和 Chrome */
        -webkit-appearance: none;
        font-size: 16px;
        color: #66b1ff;
    }

    .padding {
        padding: 10px 0px;
    }
</style>

<body>
    <div id="app">
        <template>
            <div class="pannel">
                <div class="pannel"><el-input v-model="players[0].name" placeholder="选手名" autocomplete="on" autofocus
                        style="width: auto;"></el-input>VS<el-input v-model="players[1].name" placeholder="选手名"
                        autocomplete="on" style="width: auto;"></el-input></div>
                <div class="pannel">
                    <table>
                        <tr>
                            <td><el-button @click="drawPublic" type="text">
                                    公共角色
                                </el-button></td>
                            <td><span>{{publicCharacters}}</span></td>
                        </tr>
                        <tr>
                            <th>出战</th>
                        </tr>
                        <tr v-for="(player,index) in players" :key="'pick' + index">
                            <td><el-button @click="drawPick(player.pick)" type="text">
                                    {{player.getDisplayName()}}
                                </el-button></td>
                            <td><span>{{player.pick}}</span></td>
                        </tr>
                        <tr>
                            <th>禁用</th>
                        </tr>
                        <tr v-for="(player,index) in players" :key="'ban' + index">
                            <td><el-button @click="drawBan(player)" type="text">
                                    {{player.getDisplayName()}}
                                </el-button></td>
                            <td><span>{{player.ban}}</span></td>
                        </tr>
                    </table>

                    <table width="100%" class="war-details">
                        <tr>
                            <th colspan="4" class="left">
                                <div class="padding">
                                    <div class="padding">对局详情<br></div>
                                </div>
                            </th>
                        </tr>
                        <tr>
                            <th></th>
                            <th v-for="(player,index) in players" :key="'warPlayer' + index">
                                {{player.getDisplayName()}}
                            </th>
                            <th>胜方</th>
                        </tr>
                        <tr v-for="(war,i) in wars" :key="'wars' + i">
                            <td width="10%">
                                <div class="center padding"><span>第{{upperDist[i]}}局</span></div>
                            </td>
                            <td width="35%" class="border" v-for="(player,index) in players" :key="'warPick' + index">
                                <div class="center"><el-button @click="drawWar(war, i, index)" type="text">
                                        {{war.pick[index].length>0?war.pick[index]:'选择'}}
                                    </el-button></div>
                            </td>
                            <td width="20%">
                                <div class="center"><select @change="selectVictory($event,war)">
                                        <option value="-1" label="进行中"></option>
                                        <option v-for="(player,index) in players" :key="'victory' + index"
                                            :label="player.getDisplayName()" :value="index"></option>
                                    </select></div>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="4">
                                <div class="center"><el-button type="text" @click="newWar">新增对局</el-button></div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div class="center padding">战果</div>
                            </td>
                            <td v-for="(player,index) in players" :key="'warResult' + index">
                                <div class="center">{{player.score}}</div>
                            </td>
                            <td></td>
                        </tr>
                    </table>
                </div>
                <div class="padding"></div>
                <div class="pannel">
                    <div><el-button type="primary" @click="copy()">复制</el-button></div>
                    <div><el-input type="textarea" autosize v-model="dataSource"
                            @focus="$event.currentTarget.select()"></el-input></div>
                </div>

                <div class="pannel">
                    <el-drawer :title="'请选择[' + characterSize + ']个角色，已选择：' + checkedCharacters.length"
                        :visible.sync="drawer" :with-header="true" size="50%">
                        <el-checkbox-group v-model="checkedCharacters" :min="0" :max="characterSize">
                            <el-checkbox v-for="character in characters" :label="character" :key="character"
                                :disabled="disabledCharacters.includes(character)"
                                style="margin:12px; width:40%; min-width: min-content;">{{character}}</el-checkbox>
                        </el-checkbox-group>
                        <el-row>
                            <div style="margin: 10px 30px;">
                                <el-button type="primary" @click="save()">确定</el-button>
                                <el-button style="margin:15px 0px 0px 20px" type=""
                                    @click="checkedCharacters.clear()">清空</el-button>
                            </div>
                        </el-row>
                    </el-drawer>
                </div>
            </div>
        </template>
    </div>
</body>
<script>
    const metadata = Object.freeze({
        allCharacters: Object.freeze(['甘雨', '迪奥娜', '凯亚', '重云', '神里绫华', '优菈', '芭芭拉', '行秋', '莫娜', '珊瑚宫心海', '迪卢克', '香菱', '班尼特', '宵宫', '可莉', '菲谢尔', '雷泽', '刻晴', '赛诺', '北斗', '九条裟罗', '砂糖', '琴', '凝光', '诺艾尔', '柯莱', '纯水精灵·洛蒂娅', '愚人众·藏镜仕女', '愚人众·火之债务处理人', '魔偶剑鬼', '丘丘岩盔王', '翠翎恐蕈',]),
        publicCharacters: ['莫娜'],
        publicCharacterSize: 1,
        pickCharactersSize: 10,
        banCharactersSize: 3,
        warCharactersSize: 3,
    })
    const upperDist = Object.freeze(['一', '二', '三', '四', '五', '六', '七', '八', '九', '十',])
    Array.prototype.clear = function () {
        while (this.length) {
            this.pop()
        }
        return this;
    }
    Array.prototype.add = function (arr) {
        var pushIfNotExist = ele => {
            if (!this.includes(ele)) {
                this.push(ele);
            }
        }
        if (Array.isArray(arr)) {
            arr.forEach(element => {
                pushIfNotExist(element);
            });
        } else {
            pushIfNotExist(arr);
        }
        return this;
    }
    Array.prototype.remove = function (arr) {
        var removeEle = ele => {
            if ((i = this.indexOf(ele)) > -1) {
                this.splice(i, 1);
            }
        }
        if (Array.isArray(arr)) {
            arr.forEach(element => {
                removeEle(element)
            });
        } else {
            removeEle(arr)
        }
        return this;
    }
    Array.prototype.removeIfNotExist = function (arr) {
        if (Array.isArray(arr)) {
            for (i = 0; i < this.length; i++) {
                if (!arr.includes(this[i])) {
                    this.splice(i--, 1)
                }
            }
        }
        return this;
    }
    Array.prototype.replaceAll = function (arr) {
        if (this != arr) {
            this.clear();
            this.add(arr);
        }
        return this;
    }
    class War {
        pick = [[], []];
        victory = -1;
    }
    class Player {
        static i = 0;
        name = '';
        pick = [];
        ban = [];
        score = 0;
        #opponent = [];
        #defaultName = '选手' + upperDist[Player.i++];
        constructor() {
            this.index = Player.i;
        }
        /**
         * 指定对手
         */
        setOpponent(opponent) {
            this.#opponent = opponent
        }
        getOpponent() {
            return this.#opponent
        }
        getDisplayName() {
            return this.name || this.#defaultName;
        }
    }
    class DrawConfig {
        constructor(config) {
            this.characterSize = config.characterSize;
            this.characters = config.characters || [];
            this.disabledCharacters = config.disabledCharacters || [];
            this.checkedCharacters = config.checkedCharacters || [];
            // 抽屉选择结果的承载体
            this.loadVar = config.loadVar;
        }
    }
    var Main = {
        data() {
            initPlayers = wars => {
                var players = [new Player(), new Player()];
                players[0].setOpponent(players[1]);
                players[1].setOpponent(players[0]);
                return players;
            };
            return {
                upperDist: Array.from(upperDist),
                wars: [new War()],
                players: initPlayers(),
                drawer: false,
                publicCharacters: Array.from(metadata.publicCharacters),
                characterSize: 0,
                characters: [],
                disabledCharacters: [],
                checkedCharacters: [],
            };
        },
        methods: {
            drawCharacter(config) {
                console.log('drawPick', config)
                this.drawer = true;
                this.characterSize = config.characterSize;
                this.characters.replaceAll(config.characters);
                //移除选项中没有的元素
                this.checkedCharacters.replaceAll(config.checkedCharacters).removeIfNotExist(this.characters);
                this.disabledCharacters.replaceAll(config.disabledCharacters);
                this.save = function () {
                    config.loadVar.replaceAll(this.checkedCharacters);
                    if (config.loadVar.length != this.characterSize) {
                        this.$message.error('请选择' + this.characterSize + '个角色');
                    }
                    this.drawer = false;
                }
            },
            drawPublic() {
                this.drawCharacter(new DrawConfig({
                    characterSize: metadata.publicCharacterSize,
                    characters: metadata.allCharacters,
                    loadVar: this.publicCharacters,
                }))
            },
            drawPick(pickCharacters) {
                this.drawCharacter(new DrawConfig({
                    characterSize: metadata.pickCharactersSize,
                    characters: Array.from(metadata.allCharacters).remove(this.publicCharacters),
                    checkedCharacters: pickCharacters,
                    loadVar: pickCharacters,
                }))
            },
            drawBan(player) {
                var config = new DrawConfig({
                    characterSize: metadata.banCharactersSize,
                    characters: player.getOpponent().pick,
                    loadVar: player.ban,
                });
                this.drawCharacter(config)
            },
            drawWar(war, roundIndex, playerIndex) {
                this.drawCharacter(new DrawConfig({
                    characterSize: metadata.warCharactersSize,
                    characters: this.getEnabledCharacters(roundIndex, playerIndex),
                    loadVar: war.pick[playerIndex],
                }))
            },
            getEnabledCharacters(roundIndex, playerIndex) {
                var player = this.players[playerIndex];
                //备战角色去除被ban角色
                var arr = Array.from(player.pick).remove(player.getOpponent().ban)
                //去除获胜角色
                for (i = 0; i < roundIndex; i++) {
                    var war = this.wars[i];
                    if (war.victory == playerIndex) {
                        arr.remove(war.pick[playerIndex]);
                    }
                }
                //增加公共角色
                arr.add(this.publicCharacters);
                return arr;
            },
            newWar() {
                this.wars.push(new War());
            },
            selectVictory(event, war) {
                var value = event.target.options[event.target.selectedIndex].value;
                war.victory = value;
                //更新分数
                this.countScore();
            },
            countScore() {
                var score0 = 0;
                var score1 = 0;
                this.wars.forEach(war => {
                    if (war.victory == 0) {
                        score0++;
                    } else if (war.victory == 1) {
                        score1++;
                    }
                });
                this.players[0].score = score0;
                this.players[1].score = score1;
            },
            copy() {
                navigator.clipboard.writeText(this.dataSource).then(_ => {
                    this.$message({
                        message: '复制成功',
                        type: 'success'
                    })
                }, _ => {
                    this.$message.error('复制失败');
                });
            },
        },
        computed: {
            dataSource: {
                get() {
                    return JSON.stringify({
                        players: this.players,
                        wars: this.wars,
                        publicCharacters: this.publicCharacters,
                    })
                },
                set(val) {
                    var data = JSON.parse(val);
                    console.log(data);
                    try {
                        data.players.forEach((player, i) => {
                            this.players[i].name = player.name;
                            this.players[i].pick.replaceAll(player.pick);
                            this.players[i].ban.replaceAll(player.ban);
                            this.players[i].score = player.score;
                        });
                        data.wars.forEach((war, i) => {
                            if (i == this.wars.length) {
                                this.wars.push(new War())
                            }
                            this.wars[i].pick.replaceAll(war.pick);
                            this.wars[i].victory = war.victory;
                        });
                        this.$message({
                            message: '解析成功',
                            type: 'success'
                        })
                    } catch (e) {
                        console.log(e);
                        this.$message.error('解析错误')
                    }
                }
            }
        }
    }
    var vue = new Vue(Main);
    vue.$mount('#app')
</script>

</html>